﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace UltraGridActiveRowAppearance
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraGrid1.DisplayLayout.Override.ActiveRowAppearance.BackColor = Color.Yellow;
            ultraGrid1.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.CellSelect;
            ultraGrid1.DrawFilter = new MyDraw1();
        }

    }

    public class MyDraw1 : IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            EditorWithTextUIElement slot = drawParams.Element as EditorWithTextUIElement;

            if (drawPhase == DrawPhase.AfterDrawBackColor && slot != null)
            {
                if (slot.SelectableItem.IsSelected)
                {
                    drawParams.AppearanceData.BackColor = Color.Red;
                    drawParams.DrawBackColor(ref drawParams.AppearanceData, new Rectangle(slot.Rect.X, slot.Rect.Y, slot.Rect.Width, slot.Rect.Height), new Rectangle(slot.Rect.X, slot.Rect.Y, slot.Rect.Width, slot.Rect.Height), false);
                    Debug.WriteLine(DateTime.Now.ToString());
                }
            }
            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            EditorWithTextUIElement slot = drawParams.Element as EditorWithTextUIElement;
            if (slot != null)
                return DrawPhase.AfterDrawBackColor;
            else
                return DrawPhase.None;
        }
    }
}
